function u=evalAtVertices(fun,q)
%

  dim=size(q,1);nq=size(q,2);
  if isnumeric(fun)
    if length(fun)==1, u=fun*ones(nq,1);return; end
    if size(fun)==[1,nq], u=fun.';return; end 
    if size(fun)==[nq,1], u=fun;return; end
    error('1st parameter dimension mismatch : (%d,%d)',size(fun))
  end
  if iscell(fun)
    for i=1:length(fun)
      u{i}=fc_graphics4mesh.evalAtVertices(fun{i},q);
    end
    return
  end
  if strcmp(class(fun),'function_handle') 
    assert( ismember(nargin(fun),[1,dim]) ,'Number of function arguments must be 1 or %d',dim)
    if nargin(fun)==1
      u=fun(q).';
      if length(u)==1, u=u*ones(nq,1);end
    else 
      u=eval(['fun(q(1,:)',sprintf(',q(%d,:)',2:dim),').'';']) ;
      if length(u)==1, u=u*ones(nq,1);end
    end
    return
  end
  error('Incompatible 1st parameter')
end