function plotiso3Ds()
  close all
  u=@(x,y,z) cos(x).*sin(y+z);
  [q2,me2,toGlobal2]=fc_graphics4mesh.getMeshArrays('3Ds',2);
  U2=fc_graphics4mesh.evalAtVertices(u,q2);
  [q1,me1,toGlobal1]=fc_graphics4mesh.getMeshArrays('3Ds',1);
  figure(1)
  colormap('jet')
  fc_graphics4mesh.plotmesh(q2,me2,'EdgeColor','LightGray','FaceColor','None')
  hold on
  fc_graphics4mesh.plotmesh(q1,me1,'Color','black')
  fc_graphics4mesh.plotiso(q2,me2,U2,'isocolorbar',true,'format','%.3f','LineWidth',2)
  axis image;axis off
  
  figure(2)
  colormap('jet')
  fc_graphics4mesh.plot(q2,me2,U2)
  hold on
  fc_graphics4mesh.plotmesh(q1,me1,'Color','black')
  fc_graphics4mesh.plotiso(q2,me2,U2,'LineWidth',2,'Color','w')
  colorbar
  axis image;axis off
end
